unit testRoman;

interface

uses TestFrameWork, SysUtils, Roman;

  type
    TRomanTest = Class (TTestCase)
      private rc : TRomanNumeral;

      protected
        procedure SetUp; override;
        procedure TearDown; override;

      published
        procedure testRoman123;
        procedure testRoman4_10;
        procedure testRoman10_13;
        procedure testRoman14_20;
        procedure testRoman30_50;
        procedure testRoman60_100;
        procedure testRoman200_1000;
    end;

implementation


{ TRomanTest }

procedure TRomanTest.SetUp;
begin
  rc := TRomanNumeral.Create;
end;

procedure TRomanTest.TearDown;
begin
  rc.Free;
end;

procedure TRomanTest.testRoman123;
begin
  Check(rc.toRoman(1) = 'I',   '1 returned ' + rc.toRoman(1));
  Check(rc.toRoman(2) = 'II',  '2 returned ' + rc.toRoman(2));
  Check(rc.toRoman(3) = 'III', '3 returned ' + rc.toRoman(3));
end;

procedure TRomanTest.testRoman4_10;
begin
  Check(rc.toRoman(4)  = 'IV',   ' 4 returned ' + rc.toRoman(4));
  Check(rc.toRoman(5)  = 'V',    ' 5 returned ' + rc.toRoman(5));
  Check(rc.toRoman(6)  = 'VI',   ' 6 returned ' + rc.toRoman(6));
  Check(rc.toRoman(7)  = 'VII',  ' 7 returned ' + rc.toRoman(7));
  Check(rc.toRoman(8)  = 'VIII', ' 8 returned ' + rc.toRoman(8));
  Check(rc.toRoman(9)  = 'IX',   ' 9 returned ' + rc.toRoman(9));
  Check(rc.toRoman(10) = 'X',    '10 returned ' + rc.toRoman(10));
end;

procedure TRomanTest.testRoman10_13;
begin
  Check(rc.toRoman(11) = 'XI',   '11 returned ' + rc.toRoman(11));
  Check(rc.toRoman(12) = 'XII',  '12 returned ' + rc.toRoman(12));
  Check(rc.toRoman(13) = 'XIII', '13 returned ' + rc.toRoman(13));
end;

procedure TRomanTest.testRoman14_20;
begin
  Check(rc.toRoman(14) = 'XIV',   '14 returned ' + rc.toRoman(14));
  Check(rc.toRoman(15) = 'XV',    '15 returned ' + rc.toRoman(15));
  Check(rc.toRoman(16) = 'XVI',   '16 returned ' + rc.toRoman(16));
  Check(rc.toRoman(17) = 'XVII',  '17 returned ' + rc.toRoman(17));
  Check(rc.toRoman(18) = 'XVIII', '18 returned ' + rc.toRoman(18));
  Check(rc.toRoman(19) = 'XIX',   '19 returned ' + rc.toRoman(19));
  Check(rc.toRoman(20) = 'XX',    '20 returned ' + rc.toRoman(20));
end;

procedure TRomanTest.testRoman30_50;
begin
  Check(rc.toRoman(30) = 'XXX', '30 returned ' + rc.toRoman(30));
  Check(rc.toRoman(40) = 'XL',  '40 returned ' + rc.toRoman(40));
  Check(rc.toRoman(50) = 'L',   '50 returned ' + rc.toRoman(50));
end;

procedure TRomanTest.testRoman60_100;
begin
  Check(rc.toRoman(60)  = 'LX',   '60 returned ' + rc.toRoman(60));
  Check(rc.toRoman(70)  = 'LXX',  '70 returned ' + rc.toRoman(70));
  Check(rc.toRoman(80)  = 'LXXX', '80 returned ' + rc.toRoman(80));
  Check(rc.toRoman(90)  = 'XC',   '90 returned ' + rc.toRoman(90));
  Check(rc.toRoman(100) = 'C',   '100 returned ' + rc.toRoman(100));
end;

procedure TRomanTest.testRoman200_1000;
begin
  Check(rc.toRoman(200)  = 'CC',   '200 returned ' + rc.toRoman(200));
  Check(rc.toRoman(300)  = 'CCC',  '300 returned ' + rc.toRoman(300));
  Check(rc.toRoman(400)  = 'CD',   '400 returned ' + rc.toRoman(400));
  Check(rc.toRoman(500)  = 'D',    '500 returned ' + rc.toRoman(500));
  Check(rc.toRoman(600)  = 'DC',   '600 returned ' + rc.toRoman(600));
  Check(rc.toRoman(700)  = 'DCC',  '700 returned ' + rc.toRoman(700));
  Check(rc.toRoman(800)  = 'DCCC', '800 returned ' + rc.toRoman(800));
  Check(rc.toRoman(900)  = 'CM',   '900 returned ' + rc.toRoman(900));
  Check(rc.toRoman(1000) = 'M',   '1000 returned ' + rc.toRoman(1000));
end;

initialization
  RegisterTest('', TRomanTest.Suite);

end.
